package com.javaseleniumtemplate.pages;

import com.javaseleniumtemplate.bases.PageBase;
import org.openqa.selenium.By;
import org.openqa.selenium.Keys;
import org.openqa.selenium.interactions.Actions;
import org.testng.Assert;

public class RelacaoPratoXEmbalagemPage extends PageBase {

    By botaoMenu = By.xpath("//div[@class='bars']");
    By campoPesquisar = By.xpath("//section[@class='zh-container-search-menu']//input[@type='text']");
    By opcaoTelaRelacaoPratoXEmbalagem = By.xpath("//span[text() = 'Relação Prato x Embalagem']");

    By abaEmbalagemPorPrato = By.xpath("//section[@data-zh-id=\"101216688014657655813099\"]//div[@class=\"zh-tab-scroller\"]//a[text() = 'Embalagem por Prato']");
    By abaPratoPorEmbalagem = By.xpath("//section[@data-zh-id=\"101216688014657655813099\"]//div[@class=\"zh-tab-scroller\"]//a[text() = 'Prato por Embalagem']");

    By pratoPaoDeQueijo = By.xpath("//div[@data-zh-field-name=\"NMPRATO\"]//span[text() = 'PÃO DE QUEIJO']");
    By pratoTortaDeChocolateAbaEmbPorPrato = By.xpath("//div[@data-zh-field-name=\"NMPRATO\"]//span[text() = 'TORTA DE CHOCOLATE']");
    By pratoArrozBranco = By.xpath("//div[@data-zh-field-name=\"NMPRATO\"]//span[text() = 'ARROZ BRANCO']");
    By pratoFeijoadaTransportada = By.xpath("//div[@data-zh-field-name=\"NMPRATO\"]//span[text() = 'FEIJOADA TRANSPORTADA']");
    By pratoPaveDeMaracuja = By.xpath("//div[@data-zh-field-name=\"NMPRATO\"]//span[text() = 'PAVÊ DE MARACUJÁ']");
    By pratoPaveDeAbacaxiCoco = By.xpath("//div[@data-zh-field-name=\"NMPRATO\"]//span[text() = 'PAVÊ DE ABACAXI COM COCO']");
    By embalagemPanela = By.xpath("//div[@id=\"grid-9000\"]//span[text() = 'PANELA']");
    By embalagemMarmitex = By.xpath("//div[@id=\"grid-9000\"]//span[text() = 'MARMITÉX']");
    By campoQuantidade = By.id("VRQTDEPRATEMB");

    By checkBoxEmbalagemPratoLinha1 = By.xpath("//div[@id=\"grid-101216688024018271243125\"]//div[@class=\"body-content\"]/div[1]//div[@data-zh-field-name=\"__CHECKBOX\"]");
    By codigoEmbalagemPratoLinha1 = By.xpath("//div[@id=\"grid-101216688024018271243125\"]//div[@class=\"body-content\"]/div[1]//div[@data-zh-field-name=\"CDCONTAINER\"]/span");
    By nomeEmbalagemPratoLinha1 = By.xpath("//div[@id=\"grid-101216688024018271243125\"]//div[@class=\"body-content\"]/div[1]//div[@data-zh-field-name=\"NMCONTAINER\"]/span");
    By quantidadeEmbalagemPratoLinha1 = By.xpath("//div[@id=\"grid-101216688024018271243125\"]//div[@class=\"body-content\"]/div[1]//div[@data-zh-field-name=\"VRQTDEPRATEMB\"]/span");

    By botaoAdicionar = By.xpath("//div[@class=\"zh-footer-center\"]/ul/li");
    By botaoExcluir = By.xpath("//div[@class=\"zh-footer-center\"]/ul/li");
    By botaoVoltar = By.xpath("//div[@class=\"zh-footer-left\"]");
    By botaoSalvarEProximo = By.xpath("//section[@class=\"popup-container\"]//div[@class=\"zh-footer-right\"]");
    By botaoSalvarAlteracoes = By.xpath("//div[@class=\"zh-footer-right\"]");
    By botaoCancelar = By.xpath("//section[@class=\"popup-container\"]//div[@class=\"zh-footer-left\"]");
    By botaoOk = By.xpath("//section[@class=\"zh-container-alert\"]//footer[@class=\"zh-footer-alert\"]/button");
    By botaoSim = By.xpath("//section[@class=\"zh-container-alert\"]//button[@data-zh-id=\"zh-footer-alert-button-0\"]");
    By botaoCampoEmbalagem = By.xpath("//div[@id=\"NMCONTAINER\"]//span[@style=\"background-image: none; display: block;\"]");
    By botaoCampoPrato = By.xpath("//div[@id=\"NMPRATO\"]//span[@style=\"background-image: none; display: block;\"]");
    By botaoAbrirOpcoesControleTelaInicial = By.xpath("//div[@data-ng-if=\"widget.isFloatingControlVisible()\"]//div[@data-zh-floating-control]");
    By botaoPesquisarFiltro = By.xpath("//div[@class=\"control-menu\"]//li[@data-zh-id=\"zh-floating-control-custom-action-1\"]");
    By campoProcurar = By.xpath("//li[@class=\"float-action expandable fix-position-bottom opened\"]//input");

    By embAbaPratoEmbalagemLinha1 = By.xpath("//div[@id=\"grid-10121668802324194575642\"]//div[@class=\"body-content\"]/div[1]//div[@data-zh-field-name=\"NMCONTAINER\"]/span");
    By checkBoxPratoEmbalagemLinha1 = By.xpath("//div[@id=\"grid-10121668804161559854644\"]//div[@class=\"body-content\"]/div[1]/div[@data-zh-field-name=\"__CHECKBOX\"]");
    By codigoPratoEmbalagemLinha1 = By.xpath("//div[@id=\"grid-10121668804161559854644\"]//div[@class=\"body-content\"]/div[1]/div[@data-zh-field-name=\"CDPRATO\"]/span");
    By nomePratoEmbalagemLinha1 = By.xpath("//div[@id=\"grid-10121668804161559854644\"]//div[@class=\"body-content\"]/div[1]/div[@data-zh-field-name=\"NMPRATO\"]/span");
    By unidadePratoEmbalagemLinha1 = By.xpath("//div[@id=\"grid-10121668804161559854644\"]//div[@class=\"body-content\"]/div[1]/div[@data-zh-field-name=\"SGUNIDADE\"]/span");
    By quantidadePratoEmbalagemLinha1 = By.xpath("//div[@id=\"grid-10121668804161559854644\"]//div[@class=\"body-content\"]/div[1]/div[@data-zh-field-name=\"VRQTDEPRATEMB\"]/span");

    By pratoTortaChocolateAddPrato = By.xpath("//div[@id=\"grid-9000\"]//div[@data-zh-field-name=\"NMPRATO\"]//span[text() = 'TORTA DE CHOCOLATE']");
    By pratoPaoDeQueijoAddPrato = By.xpath("//div[@id=\"grid-9000\"]//div[@data-zh-field-name=\"NMPRATO\"]//span[text() = 'PÃO DE QUEIJO']");

    By mensagemAlerta = By.xpath("//section[@class=\"zh-container-alert\"]//div[@class=\"zh-alert-scroll\"]/p");
    By mensagemCantoSuperiorDireito = By.xpath("//*[@class=\"zh-notification-messages\"]//span[@class=\"notification-message-text\"]");
    By mensagemNaoHaRegistroPratoEmb = By.xpath("//div[@id=\"grid-10121668804161559854644\"]//div[@class=\"body-content\"]/div[1]//p");
    By mensagemNaoHaRegistroEmbPrato = By.xpath("//div[@id=\"grid-101216688024018271243125\"]//div[@class=\"body-content\"]/div[1]//p");
    By mensagemObrigatorioEmbalagem = By.xpath("//div[@data-zh-id=\"10121668803114359916446\"]//div[@class=\"zh-validation\"]/span");
    By mensagemObrigatorioQuantEmbalagem = By.xpath("//div[@data-zh-id=\"10121668801016715537449\"]//div[@class=\"zh-validation\"]/span[1]");
    By mensagemObrigatorioValorMinQuantEmb = By.xpath("//div[@data-zh-id=\"10121668801016715537449\"]//div[@class=\"zh-validation\"]/span[2]");
    By mensagemObrigatorioPrato = By.xpath("//div[@data-zh-id=\"10121668802329792513462\"]//div[@class=\"zh-validation\"]/span");
    By mensagemObrigatorioQuantPrato = By.xpath("//div[@data-zh-id=\"1012166880590774654466\"]//div[@class=\"zh-validation\"]/span[1]");
    By mensagemObrigatorioValorMinQuantPrato = By.xpath("//div[@data-zh-id=\"1012166880590774654466\"]//div[@class=\"zh-validation\"]/span[2]");


    public void acessarTela() {
        tempoParaAguardarTelaInicial();
        waitForElement(botaoMenu);
        click(botaoMenu);
        sendKeys(campoPesquisar, "Relação Prato x Embalagem");
        click(opcaoTelaRelacaoPratoXEmbalagem);
    }

    ////////////////////
    public void adicionarEmbalagemPrato() {
        click(abaEmbalagemPorPrato);
        click(pratoFeijoadaTransportada);
        click(botaoAdicionar);
        clicarCampoSelecionarValor(botaoCampoEmbalagem, embalagemPanela);
        sendKeys(campoQuantidade, "8,5");
        click(botaoSalvarEProximo);

        String mensagem = getText(mensagemCantoSuperiorDireito);
        String mensagemEsperada = "Salvo com sucesso.";
        Assert.assertEquals(mensagem, mensagemEsperada, "Verificação da mensagem apresentada no canto superior direiro após adicionar uma embalagem ao prato");
        click(botaoCancelar);
    }

    public void verificarEmbalagemAdicionadaPeloPrato() {
        //valores encontrados da embalagem adicionada na tela do prato, por meio da tela do prato
        String encCodigoEmbalagem = getText(codigoEmbalagemPratoLinha1);
        String encNomeEmbalagem = getText(nomeEmbalagemPratoLinha1);
        String encQuantidadeEmbalagem = getText(quantidadeEmbalagemPratoLinha1);

        //valores esperados para a embalagem adicionada na tela do prato, por meio da tela do prato
        String expCodigoEmbalagem = "00008";
        String expNomeEmbalagem = "PANELA";
        String expQuantidadeEmbalagem = "8,50000";
        Assert.assertEquals(encCodigoEmbalagem, expCodigoEmbalagem, "Verificação do código da embalagem adicionada na tela do prato");
        Assert.assertEquals(encNomeEmbalagem, expNomeEmbalagem, "Verificação do nome da embalagem adicionada na tela do prato");
        Assert.assertEquals(encQuantidadeEmbalagem, expQuantidadeEmbalagem, "Verificação da quantidade da embalagem adicionada na tela do prato");
        click(botaoVoltar);

        //acessar a aba prato por embalagem e verificar se o prato está na embalagem
        click(abaPratoPorEmbalagem);
        preencherCampoProcurarTelaInicial("PANELA");
        click(embAbaPratoEmbalagemLinha1);

        //valores encontrados do prato na embalagem adicionado por meio da tela do prato
        String encCodigoPrato = getText(codigoPratoEmbalagemLinha1);
        String encNomePrato = getText(nomePratoEmbalagemLinha1);
        String encUnidadePrato = getText(unidadePratoEmbalagemLinha1);
        String encQuantidadePrato = getText(quantidadePratoEmbalagemLinha1);

        //valores esperados do prato na embalagem adicionado por meio da tela do prato
        String expCodigoPrato = "00.01.00.001";
        String expNomePrato = "FEIJOADA TRANSPORTADA";
        String expUnidadePrato = "KG";
        String expQuantidadePrato = "8,50000";
        Assert.assertEquals(encCodigoPrato, expCodigoPrato, "Verificação do código do prato na tela da embalagem");
        Assert.assertEquals(encNomePrato, expNomePrato, "Verificação do nome do prato na tela da embalagem");
        Assert.assertEquals(encUnidadePrato, expUnidadePrato, "Verificação do unidade do prato na tela da embalagem");
        Assert.assertEquals(encQuantidadePrato, expQuantidadePrato, "Verificação do quantidade do prato na tela da embalagem");
    }

    public void excluirPratoAbaPratoEmbalagem() {
        click(checkBoxPratoEmbalagemLinha1);
        click(botaoExcluir);

        String mensagem = getText(mensagemAlerta);
        String mensagemEsperada = "Deletar o(s) registro(s)?";
        Assert.assertEquals(mensagem, mensagemEsperada, "Verificar mensagem exibida na tela após clicar para excluir o prato");
        click(botaoSim);
        mensagem = getText(mensagemCantoSuperiorDireito);
        mensagemEsperada = "Excluído com sucesso.";
        Assert.assertEquals(mensagem, mensagemEsperada, "Verificar mensagem de excluído com sucesso exibida no canto superior direito da tela");

        mensagem = getText(mensagemNaoHaRegistroPratoEmb);
        mensagemEsperada = "Não há registros";
        Assert.assertEquals(mensagem, mensagemEsperada, "Verificar mensagem de não há registro exibida no grid da lista de pratos, após a exclusão do prato");

        click(botaoVoltar);
        click(abaEmbalagemPorPrato);
        click(pratoFeijoadaTransportada);
        mensagem = getText(mensagemNaoHaRegistroEmbPrato);
        mensagemEsperada = "Não há registros";
        Assert.assertEquals(mensagem, mensagemEsperada, "Verificar mensagem de não há registro exibida no grid da lista de embalagens, após a exclusão do prato");
    }

    public void editarQuantidadeEmbalagemPrato(String valor) {
        click(abaEmbalagemPorPrato);
        click(pratoPaveDeMaracuja);
        alterarValor(quantidadeEmbalagemPratoLinha1, valor);
        tempo();
        click(botaoSalvarAlteracoes);
        tempo();


        String mensagem = getText(mensagemCantoSuperiorDireito);
        String mensagemEsperada = "Salvo com sucesso.";
        Assert.assertEquals(mensagem, mensagemEsperada, "Verificar mensagem de salvo com sucesso exibida no canto da tela após alterar a quantidade da embalagem");

        String encQuantidadeEmb = getText(quantidadeEmbalagemPratoLinha1);
        Assert.assertEquals(encQuantidadeEmb, valor, "Verificar quantidade da embalagem após a alteração");
        click(botaoVoltar);

        //acessar a aba prato por embalagem para verificar se a quantidade do prato também foi alterada
        click(abaPratoPorEmbalagem);
        preencherCampoProcurarTelaInicial("POTE DESCARTÁVEL");
        tempo();
        click(embAbaPratoEmbalagemLinha1);

        String encQuantidadePrato = getText(quantidadePratoEmbalagemLinha1);
        Assert.assertEquals(encQuantidadePrato, valor, "Verificar quantidade do prato, após a alteração da quantidade da embalagem");
        click(botaoVoltar);
        click(abaEmbalagemPorPrato);
    }


    /////////////////
    public void adicionarPratoEmbalagem() {
        click(abaPratoPorEmbalagem);
        preencherCampoProcurarTelaInicial("PLÁSTICO");
        click(embAbaPratoEmbalagemLinha1);
        tempo();
        click(botaoAdicionar);
        click(botaoCampoPrato);
        sendKeys(campoProcurar, "TORTA DE CHOCOLATE");
        click(pratoTortaChocolateAddPrato);
        sendKeys(campoQuantidade, "5");
        click(botaoSalvarEProximo);

        String mensagem = getText(mensagemCantoSuperiorDireito);
        String mensagemEsperada = "Salvo com sucesso.";
        Assert.assertEquals(mensagem, mensagemEsperada, "Verificação da mensagem apresentada no canto superior direiro após adicionar um prato à uma embalagem");
        click(botaoCancelar);
    }

    public void verificarPratoAdicionadoNaEmbalagem() {
        //valores encontrados do prato adicionado na embalagem, por meio da tela da embalagem
        String encCodigoPrato = getText(codigoPratoEmbalagemLinha1);
        String encNomePrato = getText(nomePratoEmbalagemLinha1);
        String encUnidadePrato = getText(unidadePratoEmbalagemLinha1);
        String encQuantidadePrato = getText(quantidadePratoEmbalagemLinha1);

        //valores esperados do prato adicionado na embalagem, por meio da tela da embalagem
        String expCodigoPrato = "01.00.01.000";
        String expNomePrato = "TORTA DE CHOCOLATE";
        String expUnidadePrato = "BG";
        String expQuantidadePrato = "5,00000";
        Assert.assertEquals(encCodigoPrato, expCodigoPrato, "Verificação código do prato adicionado na embalagem na tela da embalagem");
        Assert.assertEquals(encNomePrato, expNomePrato, "Verificação nome do prato adicionado na embalagem na tela da embalagem");
        Assert.assertEquals(encUnidadePrato, expUnidadePrato, "Verificação unidade do prato adicionado na embalagem na tela da embalagem");
        Assert.assertEquals(encQuantidadePrato, expQuantidadePrato, "Verificação quantidade do prato adicionado na embalagem na tela da embalagem");
        click(botaoVoltar);

        //acessar a aba embalagem por prato e verificar se a embalagem está no prato
        click(abaEmbalagemPorPrato);
        preencherCampoProcurarTelaInicial("TORTA DE CHOCOLATE");
        click(pratoTortaDeChocolateAbaEmbPorPrato);

        //valores encontrados da embalagem adicionada na tela do prato, por meio da tela da embalagem
        String encCodigoEmbalagem = getText(codigoEmbalagemPratoLinha1);
        String encNomeEmbalagem = getText(nomeEmbalagemPratoLinha1);
        String encQuantidadeEmbalagem = getText(quantidadeEmbalagemPratoLinha1);

        //valores esperados para a embalagem adicionada na tela do prato, por meio da tela da embalagem
        String expCodigoEmbalagem = "00004";
        String expNomeEmbalagem = "PLÁSTICO";
        String expQuantidadeEmbalagem = "5,00000";
        Assert.assertEquals(encCodigoEmbalagem, expCodigoEmbalagem, "Verificação do código da embalagem na tela do prato");
        Assert.assertEquals(encNomeEmbalagem, expNomeEmbalagem, "Verificação do nome da embalagem na tela do prato");
        Assert.assertEquals(encQuantidadeEmbalagem, expQuantidadeEmbalagem, "Verificação do quantidade da embalagem na tela do prato");
    }

    public void excluirEmbalagemAbaEmbalagemPrato() {
        click(checkBoxEmbalagemPratoLinha1);
        click(botaoExcluir);

        String mensagem = getText(mensagemAlerta);
        String mensagemEsperada = "Deletar o(s) registro(s)?";
        Assert.assertEquals(mensagem, mensagemEsperada, "Verificação mensagem exibida na tela após clicar para excluir a embalagem do prato");
        click(botaoSim);

        mensagem = getText(mensagemCantoSuperiorDireito);
        mensagemEsperada = "Excluído com sucesso.";
        Assert.assertEquals(mensagem, mensagemEsperada, "Verificação mensagem exibida no canto superior direito da tela após excluír a embalagem do prato");

        mensagem = getText(mensagemNaoHaRegistroEmbPrato);
        mensagemEsperada = "Não há registros";
        Assert.assertEquals(mensagem, mensagemEsperada, "Verificação mensagem de não há registros no grid da lista de embalagens do prato");

        click(botaoVoltar);
        click(abaPratoPorEmbalagem);
        preencherCampoProcurarTelaInicial("MADEIRA");
        click(embAbaPratoEmbalagemLinha1);
        mensagem = getText(mensagemNaoHaRegistroPratoEmb);
        mensagemEsperada = "Não há registros";
        Assert.assertEquals(mensagem, mensagemEsperada, "Verificação mensagem de não há registros no grid da lista de pratos na embalagem");
    }

    public void editarQuantidadePratoEmb(String valor) {
        click(abaPratoPorEmbalagem);
        preencherCampoProcurarTelaInicial("VIDRO");
        click(embAbaPratoEmbalagemLinha1);
        alterarValor(quantidadePratoEmbalagemLinha1, valor);
        click(botaoSalvarAlteracoes);

        String mensagem = getText(mensagemCantoSuperiorDireito);
        String mensagemEsperada = "Salvo com sucesso.";
        Assert.assertEquals(mensagem, mensagemEsperada, "Verificar mensagem de salco com sucesso exibida no canto da tela após alterar a quantidade do prato na embalagem");

        String encQuantidadePrato = getText(quantidadePratoEmbalagemLinha1);
        Assert.assertEquals(encQuantidadePrato, valor, "Verificar quantidade do prato na embalagem após a alteração");
        click(botaoVoltar);

        //acessar a aba embalagem por prato e verificar se a quantidade da embalagem foi alterada no prato
        click(abaEmbalagemPorPrato);
        tempo();
        click(pratoPaveDeAbacaxiCoco);
        String encQuantEmbalagem = getText(quantidadeEmbalagemPratoLinha1);
        Assert.assertEquals(encQuantEmbalagem, valor, "Verificar quantidade da embalagem no prato após a alteração");
    }


    ///////////////////
    public void camposObrigatoriosAddEmbalagem() {
        click(pratoArrozBranco);
        click(botaoAdicionar);
        click(botaoSalvarEProximo);

        String embalagem = getText(mensagemObrigatorioEmbalagem);
        String quantEmbalagem = getText(mensagemObrigatorioQuantEmbalagem);
        String valorMinQuantEmbalagem = getText(mensagemObrigatorioValorMinQuantEmb);

        String mensagemEsperadaObr = "Campo obrigatório";
        String mensagemValorMin = "Minimum value: 0";
        Assert.assertEquals(embalagem, mensagemEsperadaObr, "Verificar mensagem de campo obrigatório no campo embalagem, para adicionar uma embalagem à um prato");
        Assert.assertEquals(quantEmbalagem, mensagemEsperadaObr, "Verificar mensagem de campo obrigatório no campo quantidade, para adicionar uma embalagem à um prato");
        Assert.assertEquals(valorMinQuantEmbalagem, mensagemValorMin, "Verificar mensagem de valor mínimo de quantidade, para adicionar uma embalagem à um prato");
        click(botaoCancelar);
        click(botaoVoltar);
    }

    public void camposObrigatoriosAddPrato() {
        click(abaPratoPorEmbalagem);
        preencherCampoProcurarTelaInicial("MADEIRA");
        click(embAbaPratoEmbalagemLinha1);
        click(botaoAdicionar);
        click(botaoSalvarEProximo);

        String prato = getText(mensagemObrigatorioPrato);
        String quantPrato = getText(mensagemObrigatorioQuantPrato);
        String valorMinQuantPrato = getText(mensagemObrigatorioValorMinQuantPrato);

        String mensagemEsperadaObr = "Campo obrigatório";
        String mensagemValorMin = "Minimum value: 0";
        Assert.assertEquals(prato, mensagemEsperadaObr, "Verificar mensagem de campo obrigatório no campo prato, para adicionar um prato à uma embalagem");
        Assert.assertEquals(quantPrato, mensagemEsperadaObr, "Verificar mensagem de campo obrigatório no campo quantidade, para adicionar um prato à uma embalagem");
        Assert.assertEquals(valorMinQuantPrato, mensagemValorMin, "Verificar mensagem de valor mínimo de quantidade, para adicionar um prato à uma embalagem");
        click(botaoCancelar);
        click(botaoVoltar);
    }

    public void registroJaExisteAddEmbalagem() {
        click(pratoPaoDeQueijo);
        click(botaoAdicionar);
        click(botaoCampoEmbalagem);
        click(embalagemMarmitex);
        sendKeys(campoQuantidade, "7");
        click(botaoSalvarEProximo);

        String mensagem = getText(mensagemAlerta);
        String mensagemEsperada = "Impossível adicionar. Registro já existe.";
        Assert.assertEquals(mensagem, mensagemEsperada, "Verificar mensagem exibida na tela após tentar adicionar uma embalagem que já existe em um prato");
        click(botaoOk);
        click(botaoCancelar);
        click(botaoVoltar);
    }

    public void registroJaExisteAddPrato() {
        click(abaPratoPorEmbalagem);
        preencherCampoProcurarTelaInicial("MARMITÉX");
        click(embAbaPratoEmbalagemLinha1);
        click(botaoAdicionar);
        click(botaoCampoPrato);
        sendKeys(campoProcurar, "PÃO DE QUEIJO");
        click(pratoPaoDeQueijoAddPrato);
        sendKeys(campoQuantidade, "2");
        click(botaoSalvarEProximo);

        String mensagem = getText(mensagemAlerta);
        String mensagemEsperada = "Impossível adicionar. Registro já existe.";
        Assert.assertEquals(mensagem, mensagemEsperada, "Verificar mensagem exibida na tela após tentar adicionar um prato que já existe em uma embalagem");
        click(botaoOk);
        click(botaoCancelar);
        click(botaoVoltar);
    }


    ////////////
    private void alterarValor(By campo, String valor) {
        Actions actions = new Actions(driver);
        tempo();
        actions.click(driver.findElement(campo)).build().perform();
        tempo();
        actions.sendKeys(Keys.BACK_SPACE).build().perform();
        tempo();
        actions.sendKeys(valor).build().perform();
        tempo();
        actions.sendKeys(Keys.ENTER).build().perform();
        tempo();
    }

    private void preencherCampoProcurarTelaInicial(String texto) {
        tempo();
        tempo();
        tempo();
        tempo();
        tempo();
        tempo();
        tempo();
        if (returnClassOpened(botaoAbrirOpcoesControleTelaInicial) && !returnClassOpened(botaoPesquisarFiltro)) {
            click(botaoPesquisarFiltro);
        } else if (!returnClassOpened(botaoAbrirOpcoesControleTelaInicial)){
            click(botaoAbrirOpcoesControleTelaInicial);
            tempo();
            click(botaoPesquisarFiltro);
        }
        clearAndSendKeys(campoProcurar, texto);
        tempo();
    }

    private boolean returnClassOpened(By locator) {
        return driver.findElement(locator).getAttribute("className").contains("opened");
    }


}
